// ****************************************************
// User Defined File Loader Functions
// J. J. Weimer
// 2007.08.13

#pragma version = 1.04
#pragma rtGlobals = 1
#pragma IgorVersion=6.0

// ****************************************************

Function udFLZeroStructure(udFL)
	STRUCT udFLStandardStructure &udFL
	
	udFL.mimetype = ""
	udFL.extensions = ""
	udFL.itemsType = 0
	udFL.itemsDim[0] = 0
	udFL.itemsDim[1] = 0
	udFL.itemsDim[2] = 0
	udFL.itemsDim[3] = 0
	udFL.procModes = "Auto;"
	udFL.eventCode = 0
	udFL.userCtrl = 0
	udFL.userData = ""
	udFL.reportCtrl = 0
	udFL.plugIns = FunctionList("udFLPlugIn*",";","KIND:6")
	udFL.pathStr = ""
	udFL.fileList = ""
	udFL.returnCtrl = 0
	udFL.toFolder = "root:"
	udFL.itemsCount = 0
	udFL.itemsList = ""
	udFL.errCode = 0
	udFL.errMsg = ""
	
	return 0
	
end

// ****************************************************
// Igor Pro User Defined File Loader Set Data Folder

Function udFLSetDataFolder(udFL,[setit])
	STRUCT udFLStandardStructure &udFL
	variable setit
	
	if (strlen(udFL.toFolder)==0)
		return -1
	endif
	
	string subfolder
	variable ic = 1
	
	string cdf = GetDataFolder(1)
	SetDataFolder root:
	
	do
		subfolder = StringFromList(ic,udFL.toFolder,":")
		if (strlen(subfolder) == 0)
			break
		endif
		NewDataFolder/O/S $subfolder
		ic += 1
	while(1)
	
	if (!ParamIsDefault(setit))
		if (!setit)
			SetDataFolder $cdf
		endif
	endif
	
	return 0
	
end

// ****************************************************
// Igor Pro User Defined File Loader Assure File Paths

Function udFLAssureFilePaths(udFL)
	STRUCT udFLStandardStructure &udFL
	
	variable ic, nc = ItemsInList(udFL.fileList), fpok = 1
	string pnameo, pnamef, nflist = ""
	
	pnameo = ParseFilePath(1,StringFromList(0,udFL.fileList),":",1,0)
	if (strlen(udFL.pathStr)==0)
		if (nc==1)
			if (strlen(pnameo)==0)
				return -1
			else
				nflist = ParseFilePath(0,StringFromList(0,udFL.fileList),":",1,0) + ";"
			endif
		else
			for (ic=0;ic<nc;ic+=1)
				pnamef = ParseFilePath(1,StringFromList(ic,udFL.fileList),":",1,0)
				if (strlen(pnamef)==0)
					return -1
				endif
				if (cmpstr(pnamef,pnameo)!=0)
					fpok = 0
				else
					nflist += ParseFilePath(0,StringFromList(ic,udFL.fileList),":",1,0) + ";"
				endif
			endfor
		endif
	endif
	if (fpok)
		udFL.fileList = nflist
		udFL.pathStr = pnameo
	else
		udFL.pathStr = ""
	endif
	
	return nc
end

// ****************************************************
// Igor Pro User Defined File Loader Set Error
//

Function udFLSetError(udFL,errStr,errCode)
	STRUCT udFLStandardStructure &udFL
	string errStr
	variable errCode
	
	udFL.errMsg = errStr
	udFL.errCode = errCode
	return 0
end

// ****************************************************
// Igor Pro User Define File Loader Query procModes

//Function/S udFLQueryprocModes(fp,udFL)
//	string fp
//	STRUCT udFLStandardStructure &udFL

Function/S udFLQueryprocModes(fp)
	string fp

	STRUCT udFLStandardStructure udFL
	
	FUNCREF udFLProtoFunc f = $fp
	udFL.userCtrl=-1
	f(udFL)
	return udFL.procModes
end

// the proto function that defines the loader function format

Function udFLProtoFunc(udFL)
	STRUCT udFLStandardStructure &udFL
	
	udFL.userData = "no data yet"
	udFL.procModes = "Auto;Others TBD;"
end
